--- src/backend/storage/file/fd.c.orig	2014-08-18 14:10:36.937017089 -0400
+++ src/backend/storage/file/fd.c	2014-08-19 16:56:13.655197058 -0400
@@ -77,6 +77,9 @@
 #include "utils/guc.h"
 #include "utils/resowner_private.h"
 
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+#include "aio.h"
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
 
 /*
  * We must leave some file descriptors free for system(), the dynamic loader,
@@ -123,6 +126,10 @@ int			max_files_per_process = 1000;
  */
 int			max_safe_fds = 32;	/* default if not changed */
 
+#ifdef USE_AIO_SIGEVENT                                    /*    signal non-originator waiters instead of letting them poll */
+extern long num_startedaio;
+extern long num_cancelledaio;
+#endif /*  USE_AIO_SIGEVENT    */
 
 /* Debugging.... */
 
@@ -1239,6 +1246,10 @@ FileClose(File file)
  * We could add an implementation using libaio in the future; but note that
  * this API is inappropriate for libaio, which wants to have a buffer provided
  * to read into.
+ * Also note that a new, different implementation of asynchronous prefetch
+ * using librt,  not libaio,  is provided by the two functions following this one,
+ * FileStartaio and FileCompleteaio.   These also require to have a buffer provided
+ * to read into,  which the new async_io support provides.
  */
 int
 FilePrefetch(File file, off_t offset, int amount)
@@ -1266,6 +1277,207 @@ FilePrefetch(File file, off_t offset, in
 #endif
 }
 
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+/*
+ * FileInitaio - initialize the aio subsystem max number of threads and max number of requests
+ *  input parms
+ *  max_aio_threads;    maximum number of threads
+ *  max_aio_num;        maximum number of concurrent aio read requests
+ *
+ *  on linux, man page for the librt implemenation of aio_init() says :
+ *         This function is a GNU extension.
+ *  If your posix aio does not have it,   then add the following line to 
+ *        src/include/pg_config_manual.h
+ *    #define DONT_HAVE_AIO_INIT
+ *  to render it as a no-op
+ */
+void
+FileInitaio(int max_aio_threads, int max_aio_num )
+{
+#ifndef DONT_HAVE_AIO_INIT
+    struct aioinit aioinit_struct;  /*  structure to pass to aio_init */
+
+    aioinit_struct.aio_threads = max_aio_threads; /*     maximum number of threads */
+    aioinit_struct.aio_num = max_aio_num;         /*     maximum number of concurrent aio read requests */
+    aioinit_struct.aio_idle_time = 1;             /*     we dont want to alter this but aio_init does not ignore it so set to the default */
+    aio_init(&aioinit_struct);
+#endif  /* ndef DONT_HAVE_AIO_INIT */
+    return;
+}
+
+/*
+ * FileStartaio - initiate asynchronous read of a given range of the file.
+ * The logical seek position is unaffected.
+ *
+ * use standard posix aio (librt)
+ *  ASSUME   BufferAiocb.aio_buf already set to -> buffer by caller
+ *  return 0 if successfully started,  else non-zero
+ */
+int
+FileStartaio(File file, off_t offset, int amount , char *aiocbp
+#ifdef USE_AIO_SIGEVENT                                    /*    signal  non-originator waiters instead of letting them poll */
+            , unsigned long BAiocbaioOrdinal               /*    ordinal number of this aio in backend's sequence  */
+#endif /*  USE_AIO_SIGEVENT    */
+                      )
+{
+	int	returnCode;
+        struct aiocb *my_aiocbp = (struct aiocb *)aiocbp;
+
+	Assert(FileIsValid(file));
+
+	DO_DB(elog(LOG, "FileStartaio: %d (%s) " INT64_FORMAT " %d",
+			   file, VfdCache[file].fileName,
+			   (int64) offset, amount));
+
+	returnCode = FileAccess(file);
+	if (returnCode >= 0) {
+
+            my_aiocbp->aio_fildes = VfdCache[file].fd;
+            my_aiocbp->aio_lio_opcode = LIO_READ;
+            my_aiocbp->aio_nbytes = amount;
+            my_aiocbp->aio_offset = offset;
+#ifdef USE_AIO_SIGEVENT                                    /*    signal non-originator waiters instead of letting them poll */
+            my_aiocbp->aio_sigevent.sigev_notify = SIGEV_SIGNAL;
+            my_aiocbp->aio_sigevent.sigev_signo = AIO_SIGEVENT_SIGNALNUM;
+            my_aiocbp->aio_sigevent.sigev_value.sival_ptr = (void *)BAiocbaioOrdinal; /*  ordinal number of this aio */
+#endif /*  USE_AIO_SIGEVENT    */
+            returnCode = aio_read(my_aiocbp);
+#ifdef USE_AIO_SIGEVENT                                    /*    signal non-originator waiters instead of letting them poll */
+            if (returnCode == 0) {
+				num_startedaio++;
+            }
+#endif /*  USE_AIO_SIGEVENT    */
+        }
+
+	return returnCode;
+}
+
+/*
+ * FileCompleteaio - complete asynchronous aio read
+ * normal_wait indicates whether to cancel or wait -
+ *                -1 <=> check - dont wait or cancel but report whether complete
+ *                 0 <=> cancel
+ *                 1 <=> wait by polling the aiocb or waiting on signal i.e. non-originator
+ *                 2 <=> wait by suspending on the aiocb                i.e. originator
+ *
+ * use standard posix aio (librt)
+ *  return 0 if successfull and did not have to wait,
+ *         1 if successfull and had to wait,
+ *    else x'ff'
+ */
+int
+FileCompleteaio( char *aiocbp , int normal_wait
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on signal instead of polling */
+            , int (*BufAWaitAioCompletion)(char *)  /*  function to await completion if non-originator */
+            , char *BAiocbP /* pointer to BAIOcb  */
+#endif /*  USE_AIO_SIGEVENT    */
+ )
+{
+	int	returnCode;
+	int	aio_errno;
+        struct aiocb *my_aiocbp = (struct aiocb *)aiocbp;
+        const struct aiocb const*cblist[1];
+        int fd;
+        struct timespec my_timeout = { 0 , 10000 };
+        struct timespec *suspend_timeout_P; /*  the timeout actually used depending on normal_wait */
+        int max_polls;
+
+        fd = my_aiocbp->aio_fildes;
+        cblist[0] = my_aiocbp;
+
+        returnCode = aio_errno = aio_error(my_aiocbp);
+        /* note that aio_error returns 0 if op already completed successfully */
+
+        /*  first handle normal case of waiting for op to complete  */
+        if (normal_wait > 0) {
+            /*   if told not to poll,   then specify no timeout  */
+            suspend_timeout_P = ( (normal_wait == 1) ? &my_timeout : (struct timespec *)0 );
+
+            while (aio_errno == EINPROGRESS) {
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on signal instead of polling */
+                if (normal_wait == 1) { /*   told to wait on signal */
+                    returnCode = aio_errno = (*BufAWaitAioCompletion)(BAiocbP); /*  wait for completion */
+				} else {
+#endif /*  USE_AIO_SIGEVENT    */
+                    max_polls = 256;
+                    my_timeout.tv_sec = 0; my_timeout.tv_nsec = 10000;
+                    returnCode = aio_suspend(cblist , 1 , suspend_timeout_P);
+                    while (    (returnCode < 0) && (max_polls-- > 0)
+                            && ((EAGAIN == errno) || (EINTR == errno))
+                          ) {
+                        my_timeout.tv_sec = 0; my_timeout.tv_nsec = 10000;
+                        returnCode = aio_suspend(cblist , 1 , suspend_timeout_P);
+                    }
+
+                    returnCode = aio_errno = aio_error(my_aiocbp);
+
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on signal instead of polling */
+                }
+#endif /*  USE_AIO_SIGEVENT    */
+                /*  now return_code is from aio_error  */
+                if (returnCode == 0) {
+                    returnCode = 1;    /*  successful but had to wait */
+                }
+            }
+            if (aio_errno) {
+                elog(LOG, "FileCompleteaio: normal_wait= %d fd= %d aio_errno= %d", normal_wait, fd, aio_errno);
+                returnCode = 0xff; /*  unsuccessful */
+            }
+
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on signal instead of polling */
+            /*   if this bkend is the originator, and therefore has the responsibility
+            **   to post suspended waiters,  then do so now.
+            **   140814 : Actually best not to do so :
+            **   because  mutually redundant with the same functionality in BufHandlSigAsync.
+            **   at one time we thought that it was necessary to do so here in the mistaken belief
+            **   that there could be cases where
+            **          . an aio is started 
+            **          . no signal is subsequently delivered until after the *next* aio is started
+            **   but in fact we have found that,  after any aio_read is started,
+            **   at least one signal will be delivered after it completes
+            **   even if no subequent aio_read is started.
+            if (    (normal_wait == 2)  **   originator   **
+                     **     there are several places where originator might post suspended waiters :
+                      *      .  BufCheckAsync if cancelling aio
+                      *      .  here
+                      *      .  in BufHandlSigAsync  ( called if signal is delivered )
+                      *      The last two appear to be mutually redundant,
+                      *      but signals are not always delivered
+                      *      Fortunately it does no harm if both cases execute simultaneously
+                      *      because each serializes on the waiters list
+                      **
+               ) {
+                    BufPostAioWaiters(BAiocbaiolockP);
+            }
+            */
+#endif /*  USE_AIO_SIGEVENT    */
+        } else {                    /* check or cancel */
+            if (normal_wait == 0) { /* cancel */
+				if (aio_errno == EINPROGRESS) {
+					do {
+							max_polls = 256;
+							my_timeout.tv_sec = 0; my_timeout.tv_nsec = 10000;
+							returnCode = aio_cancel(fd, my_aiocbp);
+							while ((returnCode == AIO_NOTCANCELED) && (max_polls-- > 0)) {
+								my_timeout.tv_sec = 0; my_timeout.tv_nsec = 10000;
+								returnCode = aio_cancel(fd, my_aiocbp);
+							}
+						returnCode = aio_errno = aio_error(my_aiocbp);
+					} while (aio_errno == EINPROGRESS);
+					returnCode = 0xff; /*  unsuccessful */
+				}
+			}
+            if (returnCode != 0)
+                returnCode = 0xff; /*  unsuccessful */
+        }
+
+	DO_DB(elog(LOG, "FileCompleteaio: %d %d",
+			   fd, returnCode));
+
+	return returnCode;
+}
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+
 int
 FileRead(File file, char *buffer, int amount)
 {
--- src/backend/storage/lmgr/proc.c.orig	2014-08-18 14:10:36.941017108 -0400
+++ src/backend/storage/lmgr/proc.c	2014-08-19 16:56:13.695197201 -0400
@@ -52,6 +52,7 @@
 #include "utils/timeout.h"
 #include "utils/timestamp.h"
 
+extern pid_t this_backend_pid;     /*   pid of this backend */
 
 /* GUC variables */
 int			DeadlockTimeout = 1000;
@@ -361,6 +362,7 @@ InitProcess(void)
 	MyPgXact->xid = InvalidTransactionId;
 	MyPgXact->xmin = InvalidTransactionId;
 	MyProc->pid = MyProcPid;
+        this_backend_pid = getpid();    /*    pid of this backend */
 	/* backendId, databaseId and roleId will be filled in later */
 	MyProc->backendId = InvalidBackendId;
 	MyProc->databaseId = InvalidOid;
@@ -536,6 +538,9 @@ InitAuxiliaryProcess(void)
 	MyProc->lwWaiting = false;
 	MyProc->lwWaitMode = 0;
 	MyProc->lwWaitLink = NULL;
+#if defined(USE_AIO_ATOMIC_BUILTIN_COMP_SWAP) && defined(USE_AIO_SIGEVENT)
+	MyProc->BAiocbWaiterLink = NULL;
+#endif
 	MyProc->waitLock = NULL;
 	MyProc->waitProcLock = NULL;
 #ifdef USE_ASSERT_CHECKING
